#!/usr/bin/python

def is_banned(c, ip):
    c.execute(
    """SELECT COUNT(*) FROM bans
    WHERE min_ip <= %s AND %s <= max_ip""",
    (ip, ip))
    return (c.fetchone()[0] != 0)

def update_ban(c, ip):
    c.execute(
    """SELECT sum(x.spam>0 and x.spam<5), count(x.spam>0 and x.spam<5)
    FROM votes as v USE INDEX (ip_t), votes as x
    WHERE v.ip=%s and v.board=x.board and v.post=x.post and v.spam>0 and v.spam<5 and v.ip!=x.ip and v.t > (current_timestamp - interval 30 day)""", (ip,))
    m, n = c.fetchone()
    if m == None:
        m = 0
    c.execute(
    """SELECT sum(x.spam=4), count(x.spam=4)
    FROM votes as v USE INDEX (ip_t), votes as x
    WHERE v.ip=%s and v.board=x.board and v.post=x.post and v.spam=4 and v.ip!=x.ip and v.t > (current_timestamp - interval 30 day)""", (ip,))
    m2, n2 = c.fetchone()
    if m2 == None:
        m2 = 0
    ban = (4*m < n-3) or (4*m2 < n2-3)
    was_banned = is_banned(c, ip)
    if ban and not was_banned:
        c.execute("INSERT IGNORE INTO bans (min_ip, max_ip, auto) VALUES (%s, %s, 1)""", (ip, ip))
        c.execute("""UPDATE posts AS p LEFT JOIN votes AS v ON v.board=p.board AND v.post=p.post AND v.ip!=p.ip AND (
            SELECT COUNT(*) FROM bans WHERE min_ip<=v.ip AND v.ip<=max_ip
        )=0 AND v.t=(
            SELECT MAX(x.t) FROM votes AS x WHERE x.board=v.board AND x.post=v.post AND x.ip!=p.ip
        )
        SET p.spam=v.spam,
            p.ip=(CASE WHEN v.ip IS NULL THEN p.ip ELSE v.ip END),
            p.t=(CASE WHEN v.t IS NULL THEN p.t ELSE v.t END)
        WHERE p.ip=%s""", (ip,))
    if not ban and was_banned:
        c.execute("""DELETE FROM bans WHERE auto=1 AND min_ip=%s AND max_ip=%s""", (ip, ip))
    return ban

if __name__ == '__main__':
    import base, cgi

    db = base.db()
    c = db.cursor()

    form = cgi.FieldStorage()
    if 'ips' in form:
        ips = [long(x) for x in form['ips'].value.split(' ')]
    else:
        c.execute("""SELECT min_ip FROM bans WHERE auto=1 AND min_ip=max_ip""")
        ips = [x[0] for x in c.fetchall()]

    print 'Status: 200 OK\n'

    for ip in ips:
        b = update_ban(c, ip)
        if 'totem' in form:
            print ip, b

    c.close()
    db.commit()
    db.close()
