#!/usr/bin/python
import base, captcha, cgi, ban, sys, urlparse

def flag(board, post, spam, thread, version=-1, comment=None):
    db = base.db()
    c = db.cursor()
    ip = base.ip()

    c.execute(
    """SELECT COUNT(*) FROM votes
    WHERE board = %s AND post = %s AND ip = %s""",
    (board, post, ip))
    voted = (c.fetchone()[0] != 0)

    c.execute(
    """SELECT COUNT(*) FROM posts
    WHERE board = %s AND post = %s AND ip = %s""",
    (board, post, ip))
    lastvote = (c.fetchone()[0] != 0)

    c.execute(
    """INSERT INTO log
    (board, post, ip, spam, thread, version)
    VALUES (%s, %s, %s, %s, %s, %s)""",
    (board, post, ip, spam, thread, version))

    c.execute(
    """INSERT INTO votes
    (board, post, ip, spam)
    VALUES (%s, %s, %s, %s)
    ON DUPLICATE KEY UPDATE
    spam = VALUES(spam), t = CURRENT_TIMESTAMP""",
    (board, post, ip, spam))

    c.execute(
    """SELECT SUM(spam>0 and spam<5), SUM(spam=4), COUNT(*) FROM votes
    WHERE board = %s AND post = %s""",
    (board, post))
    spam_votes, cp_votes, total_votes = c.fetchone()
    if (spam_votes != 0 and spam_votes != total_votes) or (cp_votes != 0 and cp_votes != total_votes):
        c.execute(
        """SELECT ip FROM votes
        WHERE board = %s AND post = %s AND spam > 0 AND spam < 5""",
        (board, post))
        bcands = [x[0] for x in c.fetchall()]
        for bcand in bcands:
            ban.update_ban(c, bcand)

    if spam == -1:
        c.execute(
        """SELECT COUNT(*) FROM votes
        WHERE board = %s AND post = %s AND spam>0""",
        (board, post))
        if c.fetchone()[0] != 0:
            spam = 0

    if (not voted or lastvote) and not ban.is_banned(c, ip):
        c.execute(
        """INSERT INTO posts
        (board, post, ip, spam, thread)
        VALUES (%s, %s, %s, %s, %s)
        ON DUPLICATE KEY UPDATE
        ip = VALUES(ip), spam = VALUES(spam), thread = VALUES(thread), t = CURRENT_TIMESTAMP""",
        (board, post, ip, spam, thread))
    else:
        c.execute(
        """INSERT INTO posts
        (board, post, ip, thread)
        VALUES (%s, %s, %s, %s)
        ON DUPLICATE KEY UPDATE
        t = CURRENT_TIMESTAMP""",
        (board, post, ip, thread))

    if comment != None:
        c.execute(
        """INSERT INTO comments
        (board, post, ip, comment)
        VALUES (%s, %s, %s, %s)
        ON DUPLICATE KEY UPDATE
        ip = VALUES(ip), comment = VALUES(comment), t = CURRENT_TIMESTAMP""",
        (board, post, ip, comment))

    c.close()
    db.commit()
    db.close()

form = cgi.FieldStorage()

quality = form.getvalue('quality')
if quality != None:
    try:
        link = urlparse.urlparse(quality)
        board = link.path.split('/')[1]
        thread = int(link.path.split('/')[-1])
        if link.fragment == '':
            post = thread
        else:
            post = int(''.join(c for c in link.fragment if c in '0123456789'))
        flag(board, post, -1, thread)
        print 'Status: 303 See Other\nLocation: quality.py\n'
    except:
        print 'Content-type: text/html\n\n<html><head><title>Error</title></head><body>'
        print 'Could not understand link:<br>' + cgi.escape(quality)
    sys.exit()

board = form.getvalue('board')
post = int(form.getvalue('post'))
spam = int(form.getvalue('spam'))
thread = int(form.getvalue('thread'))
version = form.getvalue('version')
seen = form.getvalue('seen')
comment = form.getvalue('comment')

#if not captcha.passed(form):
#    captcha.serve()
#    sys.exit()

minversion = 6
if not version or int(version) < minversion:
    if seen != 'true':
        msg = "outofdate"
        f = open("outofdate.html")
        try:
            msg = f.read()
        finally:
            f.close()
        if not version or int(version) < 18:
            print "Content-type: text/html\nCache-control: no-cache\n"
            print msg
        else:
            base.write_json(msg)
        sys.exit()
    else:
        print 'Status: 204 No Content\nCache-control: no-cache\n'
        sys.exit()

flag(board, post, spam, thread, version, comment)

if not version or int(version) < 18:
    print 'Status: 204 No Content\nCache-control: no-cache\n'
else:
    base.write_json("OK")
