#!/usr/bin/python
import base, cgi, sys

form = cgi.FieldStorage()
board = form['board'].value
spam_posts = {}

db = base.db()
c = db.cursor()

if 'posts' in form:
    post_list = base.SQL_List([int(s) for s in form['posts'].value.split(' ')])

    c.execute('SELECT post, spam FROM posts WHERE board = %s AND post IN %s AND spam != 0', (board, post_list))
    for x in c.fetchall():
        spam_posts[x[0]] = x[1]

    c.execute('SELECT post, spam FROM votes WHERE board = %s AND post IN %s AND ip = %s', (board, post_list, base.ip()))
    for x in c.fetchall():
        spam_posts[x[0]] = x[1]

if 'thread' in form:
    thread = form['thread'].value

    c.execute('SELECT post, spam FROM posts WHERE board = %s AND thread = %s AND spam', (board, thread))
    for x in c.fetchall():
        spam_posts[x[0]] = x[1]

    c.execute(
    """SELECT v.post, v.spam FROM votes AS v, posts as p
    WHERE v.board = p.board AND v.post = p.post
    AND v.board = %s AND p.thread = %s AND v.ip = %s""",
    (board, thread, base.ip()))
    for x in c.fetchall():
        spam_posts[x[0]] = x[1]

    c.execute("INSERT INTO threads (board, thread, gone) VALUES (%s, %s, 0) ON DUPLICATE KEY UPDATE gone = 0, t = CURRENT_TIMESTAMP", (board, thread))

c.close()
db.close()

if not 'version' in form or int(form['version'].value) < 18:
    quality = ' '.join('*'+str(x) for x in spam_posts if spam_posts[x] == -1)
    vio = ' '.join(str(x) for x in spam_posts if spam_posts[x] == 1 or spam_posts[x] == 2)
    spam = ' '.join(str(x) for x in spam_posts if spam_posts[x] == 3)
    illegal = ' '.join(str(x) for x in spam_posts if spam_posts[x] == 4)
    bad = ' '.join('*'+str(x) for x in spam_posts if spam_posts[x] == 5)
    sys.stdout.write('Content-type: text/plain\nCache-control: no-cache\n\n')
    sys.stdout.write('quality ' + quality + ' vio ' + vio + ' spam ' + spam + ' illegal ' + illegal + ' bad ' + bad)
else:
    output = {}
    spam_types = {1: 'vio', 2: 'vio', 3: 'spam', 4: 'illegal', 5: 'bad'}
    if int(form['version'].value) < 24:
        spam_types[-1] = 'quality'
    output['spam_list'] = {}
    for x in spam_posts:
        if spam_posts[x] in spam_types:
            output['spam_list'][x] = spam_types[spam_posts[x]]
    if int(form['version'].value) < 24:
        output['message'] = "newversionavailable"
        f = open("newversion.html")
        try:
            output['message'] = f.read()
        finally:
            f.close()
    base.write_json(output)
